﻿using Infragistics.Controls.Menus;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace XamMenuItemMVVMBinding
{
    public class ViewModel
    {
        public List<MenuObject> MenuObjects { get; set; }

        public List<object> ActualMenuObjects { get; set; }        

        public ViewModel()
        {
            MenuObjects = new List<MenuObject>();
            
            for(int i=0; i<5; i++)
            {
                MenuObject obj = new MenuObject() { ID = i, Header = "Parent Item " + i.ToString(), Command = new ParentCommand() };

                if (i % 2 == 0)
                {
                    obj.SubItems = new List<MenuObject>();

                    for (int j = 0; j < 3; j++)
                    {
                        MenuObject subObj = new MenuObject() { ID = j, Header = "Child Item " + j.ToString(), Command = new SubItemCommand() };
                        obj.SubItems.Add(subObj);
                    }
                }

                MenuObjects.Add(obj);
            }

            ActualMenuObjects = new List<object>();

            for(int i=0; i<3; i++)
            {
                XamMenuItem item = new XamMenuItem() { Header = "Item " + i.ToString() };
                XamMenuSeparator sep = new XamMenuSeparator();
                ActualMenuObjects.Add(item);
                ActualMenuObjects.Add(sep);
            }
        }
    }

    public class MenuObject
    {
        public int ID { get; set; }
        public string Header { get; set; }
        public ICommand Command { get; set; }
        public List<MenuObject> SubItems { get; set; }
        
    }
}
